      program findroot1
!
!       find root of function f1ofx
!
      implicit none

      external f1ofx

      double precision x
      double precision f1ofx
      double precision xinitial,xfinal,root
      double precision delta
      double precision tolnr

      double precision xx(50)
      double precision fxx(50)
      integer ie, iemax

      integer kread, kwrite
      data kread/5/, kwrite/6/
      data iemax/30/
!
      xinitial = 0.d0
      xfinal   = 1.57d0
      delta = 0.1d0
      tolnr=1.d-10

      write (kwrite,*)
      write (kwrite,*) 'Search Root via Bisection Method: '
      write (kwrite,*)

      write (kwrite,*) 'left bound :',xinitial,'  right bound :',xfinal

!        call the bisection routine

      call bisect1 (xinitial,xfinal,root,f1ofx)

      write (kwrite,*) 'root found at :',root

      write (kwrite,*)
      write (kwrite,*) 'Search Root via Newton-Raphson Secant Method : '
      write (kwrite,*)
 
!        do newton search
!        starting from xinitial

      xx(0) = xinitial
      fxx(0) = f1ofx(xx(0))
      xx(1) = xx(0) + delta
      fxx(1) = f1ofx(xx(1))

      ie=0

 20   ie=ie+1 
      if (ie.gt.iemax) stop

      write (kwrite,*) ' f(',xx(ie),') = ',fxx(ie),ie
     
      call newtonr (fxx(ie-1),fxx(ie),xx(ie-1),xx(ie),xx(ie+1),delta)
      fxx(ie+1) = f1ofx(xx(ie+1))

      if (abs(fxx(ie+1)).lt.tolnr) then

      write(6,*) ' the root of f(x) is :',fxx(ie),'  at x = ',xx(ie)

      else 
      go to 20
      endif

 
      stop 
      end 
